/***************************************************************************
                          sll.c  -  description
                             -------------------
    begin                : 04.02.04
    copyright            : (C) 2004 by Pablo Yanez Trujillo
    email                : rex@supertux.homelinux.org
    Version			: 1.0.2
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "common.h"
#include "sll.h"


TREE* createTREE(TREE** tree)
{
    TREE* tmp;
    if(tree==NULL) return *tree=NULL;
    tmp = (TREE*) malloc(sizeof(TREE));
    if (!tmp) {
      fprintf(stderr, "Error allocating	 memory\n");
      return *tree=NULL;
    }
    tmp->empty=1;
    tmp->next=NULL;
    return *tree=tmp;    
}

void killTREE(TREE* tree)
{
    TREE* tmp=tree, *next;
    while(tmp->next!=NULL) {
       next=tmp->next;
       free(tmp);
       tmp=next;
    }
}

int haveName(TREE* tree, const char* name)
{
  TREE* tmp=tree;
  if (!tree || !name) return 0;
  
  while(tmp!=NULL) {
       	if (!strcmp(tmp->name, name)) return 1;
       	tmp=tmp->next;
    	if(!tmp) return 0;
  }
  
  return 0;
}

char* getname(TREE* tree, int id)
{
    TREE* tmp=tree;
    if (!tree) return NULL;

    while(tmp!=NULL) {
    	if (tmp->id==id) return tmp->name;
      	tmp=tmp->next;
	if(!tmp) return NULL;
    } 
    
    return NULL;				 
}

int addElement(TREE* tree, const char* name, int id)
{
    TREE* tmp;
    TREE* run=tree;
    TREE* loc;
    
    if (!tree || !name) return 0;

    // is this an empty tree?
    if (tree->next==NULL && tree->empty) {
        strcpy(tree->name, name);
	tree->id=id;
	tree->empty=0;
	return 1;
    }

    // move to the last node
    while(run->next!=NULL) {
    	loc = run->next;
	run = loc;
    }

    tmp=createTREE(&tmp);
    strcpy(tmp->name, name);
    tmp->id=id;
    if (!tmp) return 0;
   
    run->next=tmp;

    return 1;    
}

